# (c) 1999-2000 Aberdeen University Electronics Research Lab
#
# THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# SOURCE CODE partly from Christoph Haenle
#
#  Originally by: Polly Huang
#    Modified by: Martin Koyabe, koyabe@erg.abdn.ac.uk
#           File: simulate_topology.tcl
#    Last update: Jan 24, 2000
#
# This script calls up create topology, create source and membership procedures and generates
# stact and heap statistics

if {[llength $argv] != 5} {
	puts "Usage: ns simulate_topology.tcl <#node> <verbose> <#group> <#member> <seed>"
	exit 0
}

set seed 0
source ../topos/general_topology.tcl
source ../membership/create_membership.tcl
source ../source/create_source.tcl

set verbose [lindex $argv 1]
set num_group [lindex $argv 2]
set num_member [lindex $argv 3]
set num_node [lindex $argv 0]
set seed [lindex $argv 4]

set rng [new RNG]
$rng seed $seed
set ns [new Simulator -multicast on]
$ns multicast
set address-format expanded 

create_topology $num_node 

set mrthandle [$ns mrtproto CtrMcast  {}]
create_source 
create_membership $num_member $num_node

$ns at 10 "$ns clearMemTrace; exit 0"

$ns run
