#
# (c) 1999-2000 Aberdeen University Electronics Research Lab
#
# THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
#
#    Modified by: Martin Koyabe, koyabe@erg.abdn.ac.uk
#           File: get-data-time
#    Last update: Jan 24, 2000
#
# This script computes average, min and max runtinmes, stack and heaps statistics and outputs to respective files
#
# Usage: awk -f get-data.awk <filename>.dat >> <output-filename>
#
# exec /usr/bin/rm -rf *.plot


BEGIN {
    min_time = 0;
    max_time = 0;
    min_temp_time = 0;
    max_temp_time = 0;
    mean_time = 0;
    time_flag = 0;    
}

# Start processing the file
{
    # Echo the line, preceded by the line number

    time = $5;
               
    if (time > max_temp_time) {
       max_time = time; 
       max_temp_time = max_time;
                  
       if (time_flag == 0) {
          min_temp_time = time;
          min_time = min_temp_time; 
          time_flag = 1;
       }                 
    } 
              
    if (time < min_temp_time) {
       min_time = time; 
       min_temp_time = min_time; 
    } 

    mean_time += (time/10.0);
}

END {
    printf("%d %.2f %.2f %.2f\n", $1, mean_time, min_time, max_time);
}






