#
# (c) 1999-2000 Aberdeen University Electronics Research Lab
#
# THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
#
#    Modified by: Martin Koyabe, koyabe@erg.abdn.ac.uk
#           File: sim-batch
#    Last update: Jan 24, 2000
#
# This script computes average, min and max runtinmes, stack and heaps statistics and outputs to respective files
#
# Usage: awk -f get-data.awk <filename>.dat >> <output-filename>
#
# exec /usr/bin/rm -rf *.plot


BEGIN {
    min_heap = 0;
    max_heap = 0;
    min_temp_heap = 0;
    max_temp_heap = 0;
    mean_heap = 0;
    heap_flag = 0;    
}

# Start processing the file
{
    # Echo the line, preceded by the line number

    heap = $8;
               
    if (heap > max_temp_heap) {
       max_heap = heap; 
       max_temp_heap = max_heap;
                  
       if (heap_flag == 0) {
          min_temp_heap = heap;
          min_heap = min_temp_heap; 
          heap_flag = 1;
       }                 
    } 
              
    if (heap < min_temp_heap) {
       min_heap = heap; 
       min_temp_heap = min_heap; 
    } 

    mean_heap += (heap/10.0);
}

END {
    printf("%d %.2f %.2f %.2f\n", $1, mean_heap, min_heap, max_heap);
}






