# (c) 1999-2000 Aberdeen University, Electronics Research Group (ERG)
#
# THIS SOFTWARE IS PROVIDED BY THE CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
#    Contributed by: Martin Koyabe, koyabe@erg.abdn.ac.uk
#              File: mftp_sim_general.tcl
#       Last update: Jan 24, 2000
#
# This script creates (1) source and (N) receiver nodes with asymmetric links.


# create network topology like this:
#                          2
#                         /.
#                        / .
#              0--------1  .
#                        \ .
#                         \.
#                          n

proc create_topology {num_node} {

     global ns node_ verbose

     # setup nodes

     for {set i 0} {$i < [expr $num_node+2]} {incr i} {
         set node_($i) [$ns node]
     }
 
     # Creating links for WAN

     if {$verbose} { puts "Creating links for WAN ...."; flush stdout }
     $ns duplex-link $node_(0) $node_(1)  2500Kb 0ms DropTail

#     $ns queue-limit $node_(0) $node_(1)  100000
#     $ns queue-limit $node_(1) $node_(0)  100000

     # Creating links for MAN with random delays

    if {$verbose} { puts -nonewline "Creating links for LAN with (1..$num_node) nodes "; flush stdout }
    for {set m 2} {$m < [expr $num_node+2]} {incr m} {
        $ns simplex-link $node_(1) $node_($m)    2500Kb [expr [expr int(rand()*1000)%150]+250]ms DropTail
        $ns simplex-link $node_($m) $node_(1)      64Kb [expr [expr int(rand()*1000)%150]+250]ms DropTail
    }

} 

# end of create_topology
